/* Copyright (c) 2000-2006 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

//---- globals
var _findingInterps = false;
var availInterps = [];
//---- functions
var phpAppInfoEx = null;
var prefExecutable = null;

/* Functions Related to pref-phpini.xul */
function PrefPhp_OnLoad()  {
    phpAppInfoEx = Components.classes["@activestate.com/koPHPInfoInstance;1"].
            createInstance(Components.interfaces.koIPHPInfoEx);

    if (parent.hPrefWindow.prefset.hasStringPref('phpDefaultInterpreter') &&
        parent.hPrefWindow.prefset.getStringPref('phpDefaultInterpreter'))
        prefExecutable = parent.hPrefWindow.prefset.getStringPref('phpDefaultInterpreter');
    else
        prefExecutable = '';
    PrefPhp_PopulatePHPInterps();

    parent.hPrefWindow.onpageload();

    // find the available PHP interps
    PrefPhp_DebuggerConfiguredMessage();

}

function OnPreferencePageLoading() {
    var extraPaths = document.getElementById("phpExtraPaths");
    extraPaths.init() // must happen after onpageload
}

var _lastIniPath = null;
var _lastInterpreterPath = null;

function PrefPhp_DebuggerConfiguredMessage()
{

    var txt = document.getElementById('debugger-configured-msg');
    var ini = document.getElementById('phpConfigFile').value;
    var availInterpList = document.getElementById('phpDefaultInterpreter');
    var interpreter = availInterpList.value;
    if (availInterpList.selectedItem && typeof(availInterpList.selectedItem.value) != 'undefined') {
        interpreter = availInterpList.selectedItem.value;
    }
    if (!interpreter && availInterps.length > 1) {
        interpreter = availInterps[1];
    }

    if (ini == _lastIniPath && interpreter == _lastInterpreterPath)
        return;

    _lastIniPath = ini;
    _lastInterpreterPath = interpreter;

    phpAppInfoEx.executablePath = interpreter;
    var text = '';
    if (!phpAppInfoEx.valid_version) {
        text = "WARNING!  PHP Version "+phpAppInfoEx.version+" will not work with the XDebug "+
               "extension.  You will need to upgrade your version of PHP.";
    }
    if (!text) {
        phpAppInfoEx.cfg_file_path = ini;
        try {
            phpAppInfoEx.autoConfigureDebugger();
        } catch(e) {
            log.exception(e);
        }
        if (phpAppInfoEx.isDebuggerExtensionLoadable) {
            text = "PHP is configured for debugging.  You can use the "+
                "configuration wizard to reconfigure if you have changed "+
                "your primary ini file.";
        } else {
            text = "WARNING!  PHP is not configured for debugging.  You can use the "+
                "configuration wizard to configure PHP for debugging.";
        }
    }
    if (txt.childNodes.length > 0) {
        txt.removeChild(txt.childNodes[0]);
    }
    txt.appendChild(document.createTextNode(text));

}

function OnPreferencePageOK(prefset)
{
    var ok = true;

    // ensure that the default PHP interpreter is valid
    var defaultInterp = prefset.getStringPref("phpDefaultInterpreter");
    if (defaultInterp != "") {
        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
            getService(Components.interfaces.koISysUtils);
        if (! koSysUtils.IsFile(defaultInterp)) {
            alert("No PHP interpreter could be found at '" + defaultInterp +
                  "'. You must make another selection for the default " +
                  "PHP interpreter.\n");
            ok = false;
            document.getElementById("phpDefaultInterpreter").focus();
        }
    }

    return ok;
}

// Populate the (tree) list of available PHP interpreters on the current
// system.
function PrefPhp_PopulatePHPInterps()
{
    var availInterpList = document.getElementById("phpDefaultInterpreter");

    // remove any existing items and add a "finding..." one
    _findingInterps = true;
    availInterpList.removeAllItems();
    availInterpList.appendItem("Finding available PHP interpreters...");

    // get a list of installed PHP interpreters
    var numFound = new Object();
    availInterps = phpAppInfoEx.FindInstallationExecutables(numFound);

    availInterpList.removeAllItems();
    availInterpList.appendItem("Find on Path",'');

    var found = false;
    var item = null;
    // populate the tree listing them
    if (availInterps.length == 0) {
        // tell the user no interpreter was found and direct them to
        // ActiveState to get one
        document.getElementById("no-avail-interps-message").removeAttribute("collapsed");
    } else {
        for (var i = 0; i < availInterps.length; i++) {
            item = availInterpList.appendItem(availInterps[i],availInterps[i]);
            if (availInterps[i] == prefExecutable) {
                availInterpList.selectedItem = item;
                found = true;
            }
        }
    }
    if (!found && prefExecutable) {
        availInterpList.selectedItem =
            availInterpList.appendItem(prefExecutable,prefExecutable);
    }
    _findingInterps = false;
}

/* Functions Related to pref-phpini.xul */

function PrefPhpIni_OnLoad()  {
    parent.initPanel();
}

function PrefPhp_SelectIni() {

    PrefPhp_DebuggerConfiguredMessage();

}

function loadIniFile() {
    var current = document.getElementById("phpConfigFile").value;
    var path = ko.filepicker.openFile(null, current, null, "INI", ["INI", "All"]);
    if (path != null) {
        document.getElementById("phpConfigFile").value = path;
    }

    PrefPhp_DebuggerConfiguredMessage();

}

function loadPHPExecutable() {
    var path = ko.filepicker.openExeFile();
    if (path != null) {
        var availInterpList = document.getElementById("phpDefaultInterpreter");
        availInterpList.selectedItem = availInterpList.appendItem(path,path);

        PrefPhp_DebuggerConfiguredMessage();

    }
}


function wizardConfigurePHP() {
    // get selected php and ini dirs
    var info = {};
    var availInterpList = document.getElementById("phpDefaultInterpreter");
    info.ini = document.getElementById('phpConfigFile').value;
    info.interpreter = availInterpList.value;
    if (availInterpList.selectedItem && typeof(availInterpList.selectedItem.value) != 'undefined') {
        info.interpreter = availInterpList.selectedItem.value;
    }
    info.ok = false;
    //XXX This dialog should NOT be modal because that it butt ugly on Mac OS
    //    X. The wizard should be re-jiggered to modify the prefs directly
    //    rather than passing them back to this prefs panel. Shane, can you do
    //    that? --TrentM
    window.openDialog(
            "chrome://komodo/content/wizards/setup/php/wizard.xul",
            "Komodo:PHPWizardSetup",
            "chrome,dialog,modal,resizable,close,centerscreen",
            info);
    if (info.ok) {
        document.getElementById('phpConfigFile').value = info.ini;
        document.getElementById('phpDefaultInterpreter').value = info.interpreter;
        availInterpList.selectedItem = availInterpList.appendItem(info.interpreter,info.interpreter);
    }
    PrefPhp_DebuggerConfiguredMessage();
}

