/* Copyright (c) 2003-2006 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

/* Routines to use Source Code Control dialogs.
 *
 * Dialogs:
 *  sccdialog_commit    Get a commit message and selected list of URLs to
 *                      commit.
 *
 */

// SCC Commit dialog.
//
// Arguments:
//  "urls" is the list of urls from which the user can choose. The URLs will
//      automatically be converted as appropriate for display using
//      uriparse.js.
//  "message" (optional) is a default check-in message.
//
// It returns null if the user cancelled the dialog. Otherwise it returns an
// object with the following attributes:
//  .message    the users commit message
//  .urls       the original set of URLs from the user *could* have selected
//              for commit
//  .selected   the URLs selected by the user for commit
//
function sccdialog_commit(urls, message /* ="" */) {
    if (typeof(urls) == 'undefined') urls = null;
    if (typeof(message) == 'undefined') message = null;

    // Show the dialog.
    var obj = new Object();
    obj.urls = urls;
    obj.message = message;
    window.openDialog("chrome://komodo/content/scc/commit.xul",
                      "_blank",
                      "chrome,modal,titlebar,resizable=yes",
                      obj);

    if (obj.retval == "OK") {
        return obj;
    } else {
        return null;
    }
}


